# -*- coding: utf-8 -*-
# Copyright 2016 by Avencall
# SPDX-License-Identifier: GPL-3.0+

from hamcrest import assert_that
from hamcrest import calling
from hamcrest import equal_to
from hamcrest import raises
from hamcrest import is_
from mock import Mock, PropertyMock
import mock, json
from mock import sentinel
from unittest import TestCase
from collections import namedtuple

from ari.exceptions import ARINotFound

from ..stasis import TransfersStasis
from ..event import TransferRecipientAnsweredEvent


class TransferBridge(object):
    def __init__(self, *initial_data, **kwargs):
        for dictionary in initial_data:
            for key in dictionary:
                setattr(self, key, dictionary[key])
        for key in kwargs:
            setattr(self, key, kwargs[key])


class TestState(TestCase):

    def setUp(self):
        self.ari = Mock()
        self.amid_client = Mock()
        self.ari_client = Mock()
        self.services = Mock()
        self.state_factory = Mock()
        self.state_persistor = Mock()
        self.xivo_uuid = 'xivo-uuid'
        self.transfer_bridge = TransferBridge({
            'api': '111'
            ,
            'client': '111'
            ,
            'event_reg': '111'
            ,
            'id': u'37e0f32e-3570-4046-ab03-379616dbdc41'
            ,
            'json':
                {
                    u'bridge_class': u'stasis'
                    ,
                    u'bridge_type': u'mixing'
                    ,
                    u'channels': [u'1480096473.7']
                    ,
                    u'creator': u'Stasis'
                    ,
                    u'id': u'3a950430-9342-4ebd-9254-ba1a5bbd8fb5'
                    ,
                    u'name': u'transfer'
                    ,
                    u'technology': u'simple_bridge'
                },
            'addChannel': '1480096473.7',
        })
        self.event = {u'timestamp': u'2016-11-28T16:50:38.905+0100',
                      u'args': [u'transfer', u'transfer_recipient_called', u'37e0f32e-3570-4046-ab03-379616dbdc41'],
                      u'type': u'StasisStart',
                      u'channel': {u'accountcode': u'', u'name': u'Local/1002@default-0000008a;1',
                                   u'language': u'fr_FR', u'caller': {u'name': u'Blake MORTIMER', u'number': u'1002'},
                                   u'creationtime': u'2016-11-28T16:50:20.277+0100', u'state': u'Up',
                                   u'connected': {u'name': u'Beno\xeet DE CHAMPIGNAC', u'number': u'1004'},
                                   u'dialplan': {u'priority': 1, u'exten': u'1002', u'context': u'default'},
                                   u'id': u'1480348220.545'}, u'application': u'callcontrol'}
        self.ari.bridges.get.return_value = self.transfer_bridge
